/[gentoo-x86]/eclass/gnome2.eclass
Gentoo

Diff of /eclass/gnome2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.62 Revision 1.94
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/gnome2.eclass,v 1.62 2005/09/08 17:19:22 leonardop Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/gnome2.eclass,v 1.94 2011/04/21 21:06:15 eva Exp $
4#
5# Authors:
6# Bruce A. Locke <blocke@shivan.org>
7# Spidler <spider@gentoo.org>
8 4
9inherit libtool gnome.org debug fdo-mime 5# @ECLASS: gnome2.eclass
6# @MAINTAINER:
7# gnome@gentoo.org
8# @BLURB:
9# @DESCRIPTION:
10# Exports portage base functions used by ebuilds written for packages using the
11# GNOME framework. For additional functions, see gnome2-utils.eclass.
10 12
11# Gnome 2 ECLASS 13inherit fdo-mime libtool gnome.org gnome2-utils
12 14
15case "${EAPI:-0}" in
16 0|1)
17 EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_preinst pkg_postinst pkg_postrm
18 ;;
19 2|3|4)
20 EXPORT_FUNCTIONS src_unpack src_prepare src_configure src_compile src_install pkg_preinst pkg_postinst pkg_postrm
21 ;;
22 *) die "EAPI=${EAPI} is not supported" ;;
23esac
24
25# @ECLASS-VARIABLE: G2CONF
26# @DEFAULT-UNSET
27# @DESCRIPTION:
13# extra configure opts passed to econf 28# Extra configure opts passed to econf
14[ -z "$G2CONF" ] && G2CONF="" 29G2CONF=${G2CONF:-""}
15 30
31# @ECLASS-VARIABLE: ELTCONF
32# @DEFAULT-UNSET
33# @DESCRIPTION:
16# extra options passed to elibtoolize 34# Extra options passed to elibtoolize
17[ -z "$ELTCONF" ] && ELTCONF="" 35ELTCONF=${ELTCONF:-""}
18 36
37# @ECLASS-VARIABLE: USE_EINSTALL
38# @DEFAULT-UNSET
39# @DEPRECATED
40# @DESCRIPTION:
41# Should we use EINSTALL instead of DESTDIR
42USE_EINSTALL=${USE_EINSTALL:-""}
43
44# @ECLASS-VARIABLE: SCROLLKEEPER_UPDATE
45# @DEPRECATED
46# @DESCRIPTION:
19# whether to run scrollkeeper for this package 47# Whether to run scrollkeeper for this package or not.
20[ -z "$SCROLLKEEPER_UPDATE" ] && SCROLLKEEPER_UPDATE="1" 48SCROLLKEEPER_UPDATE=${SCROLLKEEPER_UPDATE:-"1"}
21 49
22# use make DESTDIR=${D} install rather than einstall 50# @ECLASS-VARIABLE: DOCS
23[ -z "$USE_DESTDIR" ] && USE_DESTDIR="" 51# @DEFAULT-UNSET
52# @DESCRIPTION:
53# String containing documents passed to dodoc command.
24 54
55# @ECLASS-VARIABLE: GCONF_DEBUG
56# @DEFAULT_UNSET
57# @DESCRIPTION:
58# Whether to handle debug or not.
59# Some gnome applications support various levels of debugging (yes, no, minimum,
60# etc), but using --disable-debug also removes g_assert which makes debugging
61# harder. This variable should be set to yes for such packages for the eclass
62# to handle it properly. It will enable minimal debug with USE=-debug.
63# Note that this is most commonly found in configure.ac as GNOME_DEBUG_CHECK.
25 64
65
66if [[ ${GCONF_DEBUG} != "no" ]]; then
26IUSE="debug" 67 IUSE="debug"
68fi
27 69
28 70
29DEPEND=">=sys-apps/sed-4" 71# @FUNCTION: gnome2_src_unpack
72# @DESCRIPTION:
73# Stub function for old EAPI.
74gnome2_src_unpack() {
75 unpack ${A}
76 cd "${S}"
77 has ${EAPI:-0} 0 1 && gnome2_src_prepare
78}
30 79
80# @FUNCTION: gnome2_src_prepare
81# @DESCRIPTION:
82# Fix build of scrollkeeper documentation and run elibtoolize.
83gnome2_src_prepare() {
84 # Prevent scrollkeeper access violations
85 gnome2_omf_fix
86
87 # Run libtoolize
88 if has ${EAPI:-0} 0 1 2 3; then
89 elibtoolize ${ELTCONF}
90 else
91 # Everything is fatal EAPI 4 onwards
92 nonfatal elibtoolize ${ELTCONF}
93 fi
94
95}
96
97# @FUNCTION: gnome2_src_configure
98# @DESCRIPTION:
99# Gnome specific configure handling
31gnome2_src_configure() { 100gnome2_src_configure() {
32 101 # Update the GNOME configuration options
33 # [ -n "${ELTCONF}" ] && elibtoolize ${ELTCONF} 102 if [[ ${GCONF_DEBUG} != 'no' ]] ; then
34 elibtoolize ${ELTCONF} 103 if use debug ; then
35
36 use debug && G2CONF="${G2CONF} --enable-debug=yes" 104 G2CONF="${G2CONF} --enable-debug=yes"
105 fi
106 fi
37 107
38 # doc keyword for gtk-doc 108 # Prevent a QA warning
109 if hasq doc ${IUSE} ; then
39 G2CONF="${G2CONF} $(use_enable doc gtk-doc)" 110 G2CONF="${G2CONF} $(use_enable doc gtk-doc)"
111 fi
40 112
41 econf "$@" ${G2CONF} || die "./configure failure" 113 # Avoid sandbox violations caused by misbehaving packages (bug #128289)
114 addwrite "/root/.gnome2"
42 115
116 # GST_REGISTRY is to work around gst-inspect trying to read/write /root
117 GST_REGISTRY="${S}/registry.xml" econf "$@" ${G2CONF}
43} 118}
44 119
120# @FUNCTION: gnome2_src_compile
121# @DESCRIPTION:
122# Stub function for old EAPI.
45gnome2_src_compile() { 123gnome2_src_compile() {
46 124 has ${EAPI:-0} 0 1 && gnome2_src_configure "$@"
47 gnome2_src_configure "$@"
48 emake || die "compile failure" 125 emake || die "compile failure"
49
50} 126}
51 127
128# @FUNCTION: gnome2_src_install
129# @DESCRIPTION:
130# Gnome specific install. Handles typical GConf and scrollkeeper setup
131# in packages.
52gnome2_src_install() { 132gnome2_src_install() {
53 133 has ${EAPI:-0} 0 1 2 && ! use prefix && ED="${D}"
54 # if this is not present, scrollkeeper-update may segfault and 134 # if this is not present, scrollkeeper-update may segfault and
55 # create bogus directories in /var/lib/ 135 # create bogus directories in /var/lib/
56 dodir /var/lib/scrollkeeper 136 local sk_tmp_dir="/var/lib/scrollkeeper"
137 dodir "${sk_tmp_dir}" || die "dodir failed"
57 138
58 # we must delay gconf schema installation due to sandbox 139 # we must delay gconf schema installation due to sandbox
59 export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL="1" 140 export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL="1"
60 141
61 if [ -z "${USE_DESTDIR}" -o "${USE_DESTDIR}" = "0" ]; then 142 if [[ -z "${USE_EINSTALL}" || "${USE_EINSTALL}" = "0" ]]; then
62 einstall "scrollkeeper_localstate_dir=${D}/var/lib/scrollkeeper/" "$@" || die "einstall failed" 143 debug-print "Installing with 'make install'"
144 emake DESTDIR="${D}" "scrollkeeper_localstate_dir=${ED}${sk_tmp_dir} " "$@" install || die "install failed"
63 else 145 else
64 make DESTDIR=${D} \ 146 debug-print "Installing with 'einstall'"
65 "$@" install || die "make DESTDIR install failed" 147 einstall "scrollkeeper_localstate_dir=${ED}${sk_tmp_dir} " "$@" || die "einstall failed"
66 fi 148 fi
67 149
68 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL 150 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
69 151
70 # manual document installation 152 # Manual document installation
71 [ -n "${DOCS}" ] && dodoc ${DOCS} 153 if [[ -n "${DOCS}" ]]; then
154 dodoc ${DOCS} || die "dodoc failed"
155 fi
72 156
73 # do not keep /var/lib/scrollkeeper because: 157 # Do not keep /var/lib/scrollkeeper because:
74 # 1. scrollkeeper will get regenerated at pkg_postinst() 158 # 1. The scrollkeeper database is regenerated at pkg_postinst()
75 # 2. ${D}/var/lib/scrollkeeper contains only indexes for the current pkg 159 # 2. ${ED}/var/lib/scrollkeeper contains only indexes for the current pkg
76 # thus it makes no sense if pkg_postinst ISN'T run for some reason. 160 # thus it makes no sense if pkg_postinst ISN'T run for some reason.
77
78 if [ -z "`find ${D} -name '*.omf'`" ]; then 161 if [[ -z "$(find "${D}" -name '*.omf')" ]]; then
79 export SCROLLKEEPER_UPDATE="0" 162 export SCROLLKEEPER_UPDATE="0"
80 fi 163 fi
164 rm -rf "${ED}${sk_tmp_dir}"
81 165
82 # regenerate these in pkg_postinst()
83 rm -rf ${D}/var/lib/scrollkeeper
84 # make sure this one doesn't get in the portage db 166 # Make sure this one doesn't get in the portage db
85 rm -fr ${D}/usr/share/applications/mimeinfo.cache 167 rm -fr "${ED}/usr/share/applications/mimeinfo.cache"
86
87} 168}
88 169
89 170# @FUNCTION: gnome2_pkg_preinst
90gnome2_gconf_install() { 171# @DESCRIPTION:
91 172# Finds Icons, GConf and GSettings schemas for later handling in pkg_postinst
92 if [ -x ${ROOT}/usr/bin/gconftool-2 ] 173gnome2_pkg_preinst() {
93 then 174 gnome2_gconf_savelist
94 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL 175 gnome2_icon_savelist
95 export GCONF_CONFIG_SOURCE=`${ROOT}/usr/bin/gconftool-2 --get-default-source` 176 gnome2_schemas_savelist
96 einfo "Installing GNOME 2 GConf schemas"
97 grep "obj /etc/gconf/schemas" ${ROOT}/var/db/pkg/*/${PF}/CONTENTS | sed 's:obj \([^ ]*\) .*:\1:' | while read F; do
98 if [ -e "${F}" ]; then
99 # echo "DEBUG::gconf install ${F}"
100 ${ROOT}/usr/bin/gconftool-2 --makefile-install-rule ${F} 1>/dev/null
101 fi
102 done
103 fi
104
105} 177}
106 178
107gnome2_gconf_uninstall() { 179# @FUNCTION: gnome2_pkg_postinst
108 180# @DESCRIPTION:
109 if [ -x ${ROOT}/usr/bin/gconftool-2 ] 181# Handle scrollkeeper, GConf, GSettings, Icons, desktop and mime
110 then 182# database updates.
111 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
112 export GCONF_CONFIG_SOURCE=`${ROOT}/usr/bin/gconftool-2 --get-default-source`
113 einfo "Uninstalling GNOME 2 GConf schemas"
114 cat ${ROOT}/var/db/pkg/*/${PN}-${PVR}/CONTENTS | grep "obj /etc/gconf/schemas" | sed 's:obj \([^ ]*\) .*:\1:' |while read F; do
115 # echo "DEBUG::gconf install ${F}"
116 ${ROOT}/usr/bin/gconftool-2 --makefile-uninstall-rule ${F} 1>/dev/null
117 done
118 fi
119
120}
121
122gnome2_icon_cache_update() {
123 local updater=`which gtk-update-icon-cache`
124 if ! grep -q "obj /usr/share/icons" ${ROOT}/var/db/pkg/*/${PF}/CONTENTS \
125 || [ ! -x "$updater" ]; then
126 # Nothing to update
127 return
128 fi
129
130 ebegin "Updating icons cache"
131
132 local retval=0
133 for dir in \
134 $(find ${ROOT}/usr/share/icons -maxdepth 1 -mindepth 1 -type d); do
135 if [ -f "${dir}/index.theme" ]; then
136 $updater -qf $dir || retval=$?
137 fi
138 done
139
140 eend $retval
141}
142
143gnome2_omf_fix() {
144
145 # workaround/patch against omf.make or omf-install/Makefile.in
146 # in order to remove redundant scrollkeeper-updates.
147 # - <liquidx@gentoo.org>
148
149 local omf_makefiles
150
151 omf_makefiles="$@"
152
153 [ -f ${S}/omf-install/Makefile.in ] \
154 && omf_makefiles="${omf_makefiles} ${S}/omf-install/Makefile.in"
155
156 # FIXME: does this really work? because omf.make only gets included
157 # when autoconf/automake is run. You should directly patch
158 # the Makefile.in's
159
160 [ -f ${S}/omf.make ] \
161 && omf_makefiles="${omf_makefiles} ${S}/omf.make"
162
163 ebegin "Fixing OMF Makefiles"
164 local retval=0
165 for omf in ${omf_makefiles}; do
166 sed -i -e 's:scrollkeeper-update:true:' ${omf} || retval=$?
167 done
168 eend $retval
169
170}
171
172gnome2_scrollkeeper_update() {
173
174 if [ -x ${ROOT}/usr/bin/scrollkeeper-update ] && [ "${SCROLLKEEPER_UPDATE}" = "1" ]
175 then
176 einfo "Updating scrollkeeper database ..."
177 scrollkeeper-update -q -p ${ROOT}/var/lib/scrollkeeper
178 fi
179
180}
181
182gnome2_pkg_postinst() { 183gnome2_pkg_postinst() {
183
184 gnome2_gconf_install 184 gnome2_gconf_install
185 gnome2_scrollkeeper_update
186 fdo-mime_desktop_database_update 185 fdo-mime_desktop_database_update
187 fdo-mime_mime_database_update 186 fdo-mime_mime_database_update
188 gnome2_icon_cache_update 187 gnome2_icon_cache_update
188 gnome2_schemas_update
189 189
190 if [[ "${SCROLLKEEPER_UPDATE}" = "1" ]]; then
191 gnome2_scrollkeeper_update
192 fi
190} 193}
191 194
195# @#FUNCTION: gnome2_pkg_prerm
196# @#DESCRIPTION:
197# # FIXME Handle GConf schemas removal
192#gnome2_pkg_prerm() { 198#gnome2_pkg_prerm() {
193
194# gnome2_gconf_uninstall 199# gnome2_gconf_uninstall
195
196#} 200#}
197 201
202# @FUNCTION: gnome2_pkg_postrm
203# @DESCRIPTION:
204# Handle scrollkeeper, GSettings, Icons, desktop and mime database updates.
198gnome2_pkg_postrm() { 205gnome2_pkg_postrm() {
199
200 gnome2_scrollkeeper_update
201 fdo-mime_desktop_database_update 206 fdo-mime_desktop_database_update
202 fdo-mime_mime_database_update 207 fdo-mime_mime_database_update
203 gnome2_icon_cache_update 208 gnome2_icon_cache_update
209 gnome2_schemas_update --uninstall
204 210
211 if [[ "${SCROLLKEEPER_UPDATE}" = "1" ]]; then
212 gnome2_scrollkeeper_update
213 fi
205} 214}
206
207#EXPORT_FUNCTIONS src_compile src_install pkg_postinst pkg_prerm pkg_postrm
208EXPORT_FUNCTIONS src_compile src_install pkg_postinst pkg_postrm

Legend:
Removed from v.1.62  
changed lines
  Added in v.1.94

  ViewVC Help
Powered by ViewVC 1.1.20